\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("terdragon-defines.gp")

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}


\\-----------------------------------------------------------------------------

factor_with_repetition(n) =
{
  if(imag(n),error());
  n = real(n);
  n *= denominator(n);
  my(m = factor(n),
     s = matsize(m));
  if(s[1]==0, [],
     concat(vector(s[1],i, vector(m[i,2],j, m[i,1]))));
}
join(v,sep="") =
{
  if(#v==0,"", concat(vector(2*#v-1,i, if(i%2,Str(v[(i+1)/2]),sep))));
}
factor_string(n) = join(factor_with_repetition(n)," * ");


HD_mod_4(k) = vector_modulo([1,3,1,3, 3,1,3,1],k);
check_exact(vector(100,k,k--; HD_mod_4(k)), vector(100,k,k--; HD(k)%4));

\\ for(k=0,20, my(p=(b^k/2-P3(k))/b^k); print(real(p)*2*sqrt3^k,"  ",z_to_y(p)*2*sqrt3^k, ))
\\ vector(200,k,k--;issquare(HD(k)))
\\ vector(60,k,k--;kronecker(HD(k),29))
\\ vector(60,k,k--;core(HD(k)))
\\ vector(120,k,k--;HD(k)/core(HD(k)))
\\ vector(120,k,k--;HD(k)%4)
\\ smallest_factor(n) = if(n<2,n,factor(n)[1,]);

HD_sans_9(k) = my(h = HD(k)); if(h%9==0,h/9, h);
{
  for(k=0,40,
     print(HD_sans_9(k)%4,
           "  ", HD(k)%9,
           "  ", HD(k)/core(HD(k)),
           "  ", factor_string(HD(k))));
}


\\ print("squares");
\\ for(k=0,20000,if(issquare(HD(k)), print(k,"   ",factor_string(HD(k)))));


\\-----------------------------------------------------------------------------

hd_real(k) =   real(( (b^k/2-P3(k))/b^k )) *2*sqrt3^k;
hd_imag(k) = z_to_y(( (b^k/2-P3(k))/b^k )) *2*sqrt3^k;
check_exact(vector(100,k,k--; hd_real(k)^2 + hd_imag(k)^2), \
            vector(100,k,k--; HD(k)));

\\ vector(20,k,k--;  
\\ vector(20,k,k--;(( (b^k/2-P3(k))/b^k )) *2*sqrt3^k)
{
  for(k=3,40,
     my(s = sqrtint(HD(k)), r=HD(k)-s^2, r2=HD(k)-(s+1)^2);
     print(hd_real(k),
           "  ", hd_imag(k),
           "  ", hd_real(k)/hd_imag(k)*1.0,
           "  ", r," ",r2));
}

hd_real_by_powers(k) =
{
  1/8*( 9 * 3^floor(k/2) - vector_modulo([1, 1, 3, 3],k) ) 
  * vector_modulo([1,sqrt3],k);
}
check_exact(vector(100,k,k--; hd_real_by_powers(k)), \
            vector(100,k,k--; hd_real(k)));

hd_imag_by_real(k) =
{
  if(k<3, return(0));
  hd_real(k-3) + vector_modulo([0,0,0,1],k);
}
check_exact(vector(20,k,k+=3; hd_imag_by_real(k)), \
            vector(20,k,k+=3; hd_imag(k)));

vector(10,k,k--; hd_imag(k))
vector(10,k,k--; hd_real(k))


quit

\\-----------------------------------------------------------------------------
\\ vector(200,k,k+=5; sqrtint(HD(k)))

{
  for(k=3,400,
     my(h=HD_sans_9(k));
     print1(k"  ");
     forprime(p=2,50,
              my(s = kronecker(h,p));
              print1(s," ");
              if(s==-1,break()));
     print();
  );
}