\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("terdragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------


print("1/2 at ",terdragon_fpoint(1/2));
my(k=10); print(ternary_padded(floor(3^k/2), k));

print("1/5 at ",terdragon_fpoint(1/5));

f=fracper_to_frac([0,1,2,1,[2]], 3);
print("121222 = "f" at "terdragon_fpoint(f)*1.0);
f*1.0

\\-----------------------------------------------------------------------------

{
  k=130;
  fs=[0];
  my(verbose=0);
  my(flen=1, zlen=1);
  for(reps=1,k,
     print("reps="reps"  #fs="#fs);
     if(verbose,print("at flen="flen" zlen="zlen," #fs=",#fs));
     if(verbose && #fs<30, print("  ",fs));

     if(verbose && reps<10,
        print1("  ");
        for(i=1,#fs,
           print1(fs[i]/flen);
           while(i<#fs && fs[i+1]==flen+fs[i], i++);
           print1("--"fs[i]/flen",  "));
        print());

     if(verbose,
        my(runs=0);
        for(i=1,#fs,
           runs++;
           while(i<#fs && fs[i+1]==flen+fs[i], i++));
        print("  runs ",runs,"  mean ",#fs/runs*1.0);
       );

     my(new_fs=List([]), skip=0);
     flen/=3;
     zlen/=sqrt3;
     my(zlimit=3*zlen);
     for(i=1,#fs,
        my(f=fs[i]);
        for(step=0,2,
           my(z=terdragon_fpoint(f));
           if(abs(geom_point_y(z)  ) > zlimit, skip++; next());
           if(abs(geom_point_x(z)-f) > zlimit, skip++; next());
           listput(new_fs,f);
           f+=flen);
     );
     fs=new_fs;
     if(verbose, print("  skip ",skip));
  );
}
{
  for(i=1,#fs,
     my(z=terdragon_fpoint(fs[i]));
     print(fs[i]*1.0);
     print(" n="decimal_to_ternary(fs[i]*3^k));
     print(" x="decimal_to_ternary(floor(geom_point_x(z)*3^ceil(k/2))));
  );
}

\\ #"111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111"
\\ #"1111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111111"


\\ 0.8163604766596108788302178783
\\ cf Kempner-Mahler
\\ 0.816421509021893143708079
\\ 0.0000610    differs at bit 2^-15, and sum those bits for 2^-14
\\ printf("%f",2.0^-14)
\\ 36+6==42