\\ Copyright 2016, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
read("terdragon-defines.gp");

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------

to_ternary(987827849901957257709267726)
to_ternary(3722300847344287577212335962)

quit

\\-----------------------------------------------------------------------------

ones(k) = fromdigits(vector(k,i,1),3)/3^k;

ternary_frac(f) =
{
  my(k=valuation(denominator(f),3));
  f*=3^k;
  is_integer(f) || error();
  my(v=digits_padded(k,f));
  my(s=concat(apply(d->Str(d),v)));
  concat("0.",s);
}
{
  for(k=29,90,
     my(f=ones(k)/3,
        z=terdragon_fpoint(f));
     print("k="k" at "z);
     print("  "to_ternary(floor(real(z)*3^k)));
  );
}

