#!/usr/bin/perl -w

# Copyright 2014, 2015, 2016 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use FindBin;
use Math::PlanePath::TerdragonCurve 117; # v.117 for level_to_n_range()

use FindBin;
BEGIN { unshift @INC, $FindBin::Bin }
use lib::abs "$FindBin::Bin/../tools";
use MyTerdragon 'xy_rotate_plus60';
use MyLineSegments;
use MyPrintwrap ':all';

# uncomment this to run the ### lines
use Smart::Comments;

print "  % generated by tools/$FindBin::Script\n";

my $path = Math::PlanePath::TerdragonCurve->new;


#     *---9             36--27
#      \                    /
#   *---*                 18---9
#    \ / \                    /
#     *---*                  0
#      \
#   0---*
#
my $segments = MyLineSegments->new;
foreach my $n (3*9 .. 4*9-1,
               7*9 .. 9*9-1,
              ) {
  my ($x,$y) = $path->n_to_xy($n);
  my ($x2,$y2) = $path->n_to_xy($n+1);
  ($x,$y) = xy_rotate_plus60($x,$y);
  ($x2,$y2) = xy_rotate_plus60($x2,$y2);
  $segments->add($x,$y, $x2,$y2);
}

$Printwrap = 2;
printwrap("\\draw ");
$Printwrap += 2;
$segments->printwrap;
printwrap(";\n");

print "  % end generated\n";
exit 0;
