\\ Copyright 2015, 2017 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


default(recover,0);
read("terdragon-defines.gp")

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong "name);
     print("got  "got);
     print("want "want);
     quit(1),
     print("ok "check_count" "name));
}

\\-----------------------------------------------------------------------------
\\ minimum area rectangle

MR1(k) = rectangle_area_at_angle(hull(k), P1(k)-P2(k));
MR2(k) = rectangle_area_at_angle(hull(k), P2(k)-P3(k));
MR3(k) = rectangle_area_at_angle(hull(k), P3(k)-P4(k));
MR4(k) = rectangle_area_at_angle(hull(k), P4(k)-P5(k));
MR5(k) = rectangle_area_at_angle(hull(k), P5(k)-P6(k));
MR6(k) = rectangle_area_at_angle(hull(k), P6(k)-P7(k));
MR7(k) = rectangle_area_at_angle(hull(k), P7(k)-P1dash(k));

\\ print("MR1 ",vector(100,k,k--; if(k<6,0, MR1(k))));
\\ quit

MR_functions = [MR1,MR2,MR3,MR4,MR5,MR6,MR7];
\\ {
\\   for(k=6,20,
\\      my(v = apply(f->f(k), MR_functions),
\\         mpos = -1,
\\         m = vecmin(v,&mpos));
\\      print("k="k"  mpos="mpos"  ",m*1);
\\   );
\\ }

MR_by_vecmin(k) = vecmin(apply(f->f(k), MR_functions), &pos);

\\ {
\\   for(k=6,20,
\\      my(v = hull(k),
\\        z = P7(k)-P1dash(k));
\\      v /= z;
\\      my(vre = apply(real,v),
\\         vim = apply(z_to_y,v),
\\         vre_min, vre_max,
\\         vim_min, vim_max);
\\      vecmin(vre,&vre_min);
\\      vecmax(Vecrev(vre),&vre_max);
\\      vecmin(vim,&vim_min);
\\      vecmax(Vecrev(vim),&vim_max);
\\      print("k="k"  "vre_min" "vre_max"    "vim_min"  "vim_max);
\\   );
\\ }

MR7_width(k)  = real( (P4(k) - P4dash(k)) * conj(P7(k)-P1dash(k)) );
MR7_height(k) = z_to_y( (P7(k) - P7dash(k)) * conj(P7(k)-P1dash(k)) );

print("MR7_width ",vector(10,k,k--; if(k<6,0, MR7_width(k))));
print("MR7_height ",vector(100,k,k--; if(k<6,0, MR7_height(k))));

MR7_width_by_powers(k) =
{
  13/24 * 3^k
  + 1/24 * vector_modulo([-9, 18, -1, -30],k) * 3^floor(k/2)
  + 1/8 * vector_modulo([0, -3, -2, 1],k);
}  
check_exact(vector(10,k,k+=3; MR7_width_by_powers(k)), \
            vector(10,k,k+=3; MR7_width(k)), \
            "MR7_width")

MR7_height_by_powers(k) =
{
  sqrt3/2*(
         13/36 * 3^k
         + 1/12 * vector_modulo([-3, 6, -1, -16],k) * 3^floor(k/2)
         + 1/4  * vector_modulo([0, -1, 0, 1],k)
        );
}  
check_exact(vector(10,k,k+=3; MR7_height_by_powers(k)), \
            vector(10,k,k+=3; MR7_height(k)), \
            "MR7_height")

v = hull(6)* conj(P7(6)-P1dash(6));
Mat(v~)
vecmin(apply(real,v),&pos)
pos
vecmax(apply(real,v),&pos)
pos
83/2 - (-352)
vecmin(apply(z_to_y,v),&pos)
pos
vecmax(apply(z_to_y,v),&pos)
pos
126*sqrt3 - (-9/2*sqrt3)
(83/2 - (-352))*(126*sqrt3 - (-9/2*sqrt3))

 vector(100,k,k--; if(k<6,0, MR7_width(k)*MR7_height(k)))

\\ MR7 width*height
gMR7_numerator(x) =
{
sqrt3*(
\\     + -1/108 - 4/3*x - 27/4*x^2 - 33*x^3 - 2187/4*x^4 - 6348*x^5
     + (1/64)/(1 - x)
     + (-1/64)/(1 + x)
     + (43/576)/(1 - 3*x)
     + (-7/96)/(1 + 3*x)
     + (169/1728)/(1 - 9*x)
     + (1/64*x)/(1 + x^2)
     + (1/192 - 41/192*x)/(1 - 3*x^2)
     + (-1/192 + 5/192*x)/(1 + 3*x^2)
     + (13/288 - 127/192*x)/(1 + 9*x^2)
     + (-143/1728 - 91/192*x)/(1 - 27*x^2)
     + (-91/1728 + 247/192*x)/(1 + 27*x^2)
)
  ;
}
\\ vector(16,k,k--;MR7_numerator(k))
\\ {
\\   gf_terms((-3/256)/(1 - x)
\\            + (-1/128)/(1 + x)
\\            + (1/64 - 1/8*x)/(1 + x^2),
\\            8) * 256
\\ }
\\ {
\\   my(v = gf_terms((3/64 - 83/96*x)/(1 - 3*x^2)
\\            + (1/48 + 49/192*x)/(1 + 3*x^2),
\\            8) * 192);
\\   vector(#v,i, v[i]/3^floor((i-1)/2))
\\ }
\\ {
\\   my(v = gf_terms( (409/1152)/(1 - 3*x)
\\                   + (-73/192)/(1 + 3*x)
\\                   + (-9/64 - 71/48*x)/(1 + 9*x^2),
\\                   8)*1152);
\\   vector(#v,i, v[i]/3^(i-1))
\\ }
\\ {
\\   my(v = gf_terms(  (-89/1728 - 67/96*x)/(1 - 27*x^2)
\\                   + (25/864 + 689/192*x)/(1 + 27*x^2),
\\                   8)*1728 );
\\   vector(#v,i, v[i]/3^floor(3*(i-1)/2))
\\ }

MR7_numerator(k) =
{
sqrt3*(
       169/1728 * 9^k
       + 13/864 * vector_modulo([-9, 18, -2, -39],k)  * 3^floor(3*k/2)
       + 1/576 * vector_modulo([27, -42, -25, 212],k) * 3^k
       + 1/96 * vector_modulo([0, -18, 1, -23],k)     * 3^floor(k/2)
       + 1/64 * vector_modulo([0, 3, 0, 1],k)
      )
  ;
}
check_exact(vector(10,k,k--; MR7_numerator(k)), \
            gf_terms(gMR7_numerator(x),10), \
            "MR7_numerator")
print("MR7_numerator(6) = ",MR7_numerator(6));

P7_to_P1dash_norm(k) = norm(P7(k) - P1dash(k));
vector(100,k,k--; P7_to_P1dash_norm(k))

gP7_to_P1dash_norm(x) =
{
     + (1/4)/(1 - x)
     + (-3/16)/(1 + x)
     + (37/144)/(1 - 3*x)
     + (-5/24 + 9/8*x)/(1 + 3*x^2)
  ;
}
check_exact(gf_terms(gP7_to_P1dash_norm(x),100), \
            vector(100,k,k--; P7_to_P1dash_norm(k)), \
            "gP7_to_P1dash_norm")

P7_to_P1dash_norm_formula(k) =
{
  37/144 * 3^k
  + 1/24 * vector_modulo([-5, 27, 5, -27],k) *3^floor(k/2)
  + 1/16 * vector_modulo([1, 7],k) 
;
}
check_exact(vector(100,k,k--; P7_to_P1dash_norm_formula(k)), \
            vector(100,k,k--; P7_to_P1dash_norm(k)), \
            "P7_to_P1dash_norm_formula")

MR7_formula(k) = MR7_numerator(k) / P7_to_P1dash_norm(k);
check_exact(vector(10,k,k+=5; MR7_formula(k)), \
            vector(10,k,k+=5; MR7(k)), \
            "MR7_formula")


169/1728 /(37/144)*sqrt3
169/1728 /(37/144)*sqrt3 *1.0

print("by vecmin");
my(k=1000); MR_by_vecmin(k)/3^k*1.0
pos
print("by formulas");
my(k=1000); MR7_formula(k)/3^k*1.0

factor_with_repetition(n) =
{
  if(imag(n),error());
  n = real(n);
  n *= denominator(n);
  my(m = factor(n),
     s = matsize(m));
  if(s[1]==0, [],
     concat(vector(s[1],i, vector(m[i,2],j, m[i,1]))));
}
join(v,sep="") = concat(vector(2*#v-1,i, if(i%2,Str(v[(i+1)/2]),sep)));
factor_string(n) = join(factor_with_repetition(n),"*");

{
  print("P7_to_P1dash_norm factors");
  for(k=6,40, print(factor_with_repetition(P7_to_P1dash_norm(k))));
}
{
  print("MR7 width factors");
  for(k=6,40, print(factor_with_repetition(MR7_width(k))));
}
{
  print("MR7 height factors");
  for(k=6,40, print(factor_with_repetition(real(MR7_height_by_powers(k)/sqrt3))));
}

\\ {
\\   print("polygon_minimum_area_rectangle");
\\   for(k=0,10,
\\      print(polygon_minimum_area_rectangle(hull(k)),
\\           "    cf ",MR7_formula(k)));
\\ }


\\-----------------------------------------------------------------------------

MR7_divided(k) = {
sqrt3*(
       169/1728 * 9^k
       + 13/864 * vector_modulo([-9, 18, -2, -39],k)  * 3^floor(3*k/2)
       + 1/576 * vector_modulo([27, -42, -25, 212],k) * 3^k
       + 1/96 * vector_modulo([0, -18, 1, -23],k)     * 3^floor(k/2)
       + 1/64 * vector_modulo([0, 3, 0, 1],k)
      )
/ (  37/144 * 3^k
  + 1/24 * vector_modulo([-5, 27, 5, -27],k) *3^floor(k/2)
  + 1/16 * vector_modulo([1, 7],k) 
);
}
check_exact(vector(100,k,k+=5; MR7_divided(k)), \
            vector(100,k,k+=5; MR7(k)), \
            "MR7_divided")

MR7_divided(k) = {
sqrt3*(
  169/444 * 3^k
  +
  (
   vector_modulo([-299/5328, -559/3552, -3497/31968, -845/5328],k) * 3^floor(3*k/2)
   + vector_modulo([41/1776, -567/2368, -179/2664, 4295/21312],k) * 3^k
   + 1/96 * vector_modulo([0, -18, 1, -23],k)     * 3^floor(k/2)
   + 1/64 * vector_modulo([0, 3, 0, 1],k)
   )
  / (   37/144 * 3^k
      + 1/24 * vector_modulo([-5, 27, 5, -27],k) *3^floor(k/2)
      + 1/16 * vector_modulo([1, 7],k) 
    )
);
}
check_exact(vector(100,k,k+=5; MR7_divided(k)), \
            vector(100,k,k+=5; MR7(k)), \
            "MR7_divided")

MR7_divided(k) = {
sqrt3*(
  169/444 * 3^k
  - vector_modulo([299/1369, 1677/2738, 3497/8214, 845/1369],k)
    * 3^floor(k/2)
  + (
     vector_modulo([-491/21904, -855/87616, 471/21904, -23605/788544],k)
       * 3^k
     + vector_modulo([299/21904, 3525/43808, 811/21904, 4003/131424],k) 
       * 3^floor(k/2)
     + vector_modulo([0, 3/64, 0, 1/64],k)
   )
  / (   37/144 * 3^k
      + 1/24 * vector_modulo([-5, 27, 5, -27],k) *3^floor(k/2)
      + 1/16 * vector_modulo([1, 7],k) 
    )
);
}
check_exact(vector(100,k,k+=5; MR7_divided(k)), \
            vector(100,k,k+=5; MR7(k)), \
            "MR7_divided")



system("sleep 1");