#!/usr/bin/perl -w

# Copyright 2014, 2016, 2017, 2018 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;
use FindBin;
use Math::Complex;
use Math::PlanePath::TerdragonCurve 117; # v.117 for level_to_n_range()

BEGIN { unshift @INC, $FindBin::Bin }


my $k_limit = 8;

print "  % generated by tools/$FindBin::Script\n";

my $w6 = Math::Complex->make(1/2, sqrt(3)/2);
my $w3 = $w6 - 1;
my $b = $w6 + 1;

sub GAR_fractal {
  my ($k) = @_;
  return (1/52*(-1 + 4*$w6) * 2**$k * $b**$k
          - 1/6 *$w6  * $b**$k
          + 1/78*(- 5 + 7*$w6) * (~$w6)**$k
         )
    / (3**($k-1) - 2**($k-1))
    / $b**$k
    + .5;
}

foreach my $k (2 .. $k_limit) {
  my $z = GAR_fractal($k);
  my $x = $z->Re;
  my $y = $z->Im;
  printf "  \\node (p$k) at (%.6f, %.6f) [my dot];\n", $x,$y;
}

print "  % end generated\n";
exit 0;
