#!/usr/bin/perl -w

# Copyright 2019 Kevin Ryde
#
# This file is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation; either version 3, or (at your option) any later
# version.
#
# This file is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this file.  If not, see <http://www.gnu.org/licenses/>.


use 5.004;
use strict;

use FindBin;
use lib $FindBin::Bin;
use MyTerdragon '@dNextL_state_table','@dNextR_state_table',
  '@dNextLsub1_state_table','@dNextLsub1_state_to_name',
  '@dNextLsub1_state_to_d','$dNextLsub1_start_state';
use MyPrintwrap ':all';
use MyFLAT;
$|=1;

print "% generated by tools/$FindBin::Script\n";

printwrap_indent("% GP-DEFINE  ");
printwrap_gp_matrix([map{ [map {$_+1} @$_] } @dNextL_state_table],
                    "dNextL_state_table");
printwrap_gp_matrix([map{ [map {$_+1} @$_] } @dNextR_state_table],
                    "dNextR_state_table");

foreach my $i (0 .. $#dNextLsub1_state_to_name) {
  print "% GP-DEFINE  dNextLsub1_$dNextLsub1_state_to_name[$i] = ",$i+1,";\n";
}
print "% GP-DEFINE  dNextLsub1_start_state = ",$dNextLsub1_start_state+1,";\n";
printwrap_gp_matrix([map{ [map {$_+1} @$_] } @dNextLsub1_state_table],
                    "dNextLsub1_state_table");
printwrap_gp_vector(\@dNextLsub1_state_to_d, "dNextLsub1_state_to_d");

print "% end generated\n";
exit 0;
